"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useSelector = exports.useDispatch = exports.useStore = exports.storeProvider = void 0;
const vueReactiveStore_1 = require("./vueReactiveStore");
const vue_1 = require("vue");
const runtime_core_1 = require("@vue/runtime-core");
let store;
const storeSymbol = Symbol();
exports.storeProvider = (storeToProvide) => {
    store = storeToProvide;
    return runtime_core_1.provide(storeSymbol, storeToProvide);
};
const storeChecker = (store) => !store && console.error('[Err src]: No store has been provided or instanciated');
exports.useStore = () => {
    let store = vue_1.inject('store');
    storeChecker(store);
    return store;
};
exports.useDispatch = () => store.dispatch;
exports.useSelector = (selector) => vueReactiveStore_1.reactivitySelectorWrapper(() => selector(store.getState()), store);
