import { reactivitySelectorWrapper } from "./vueReactiveStore";
import { inject } from "vue";
import { provide } from "@vue/runtime-core";
let store;
const storeSymbol = Symbol();
export const storeProvider = (storeToProvide) => {
    store = storeToProvide;
    return provide(storeSymbol, storeToProvide);
};
const storeChecker = (store) => !store && console.error('[Err src]: No store has been provided or instanciated');
export const useStore = () => {
    let store = inject('store');
    storeChecker(store);
    return store;
};
export const useDispatch = () => store.dispatch;
export const useSelector = (selector) => reactivitySelectorWrapper(() => selector(store.getState()), store);
